import { EventEmitter, Injectable, Output } from '@angular/core';
import { Storage } from '@ionic/storage-angular';


@Injectable({
  providedIn: 'root'
})
export class StorageService{
  private _storage: Storage | null = null;
  readyState: boolean = false;
  @Output() notifyReady: EventEmitter<any> = new EventEmitter();

  constructor(private storage: Storage) {
    this.init().then(()=>{
      this.readyState = true;
      this.notifyReady.emit(this.readyState);
      console.log("ready")
    });
  }

  async init(){
    //await this.storage.defineDriver("LocalStorage");
    const storage = await this.storage.create();
    this._storage = storage;
  }

  async set(key: string, value: any){
    await this._storage?.set(key, value);
  }

  async get(key: string): Promise<any> {
    return await this._storage?.get(key);
  }
}

//More here:
//https://github.com/ionic-team/ionic-storage